<template>
  <div>
    <!-- 区域预留中心 -->
    <p-card title="区域预留中心">
      <span slot="extra">
        <p-button type="primary" style="margin-right:10px" @click="showmodel()">添加</p-button>
        <p-button type="primary" style="margin-right:10px" @click="delbatches()">批量删除</p-button>
      </span>
      <p-grid-form :label-col="{ span: 8 }" :span="8" :items="config.items" @submit="hanlderSubmit" />
      <p-table
        ref="table"
        row-key="id"
        bordered
        :columns="config.columns"
        :remoteUrl="config.remoteUrl"
        :remoteParams="remoteParams"
        :rowSelectType="2"
        :selectedRowKeys.sync="selectedRowKeys"
        :data-source="data"
      >
        <template slot="reserveCount" slot-scope="text, record">
          {{ record.reserveType == 1 ? text : text + '%' }}
        </template>
        <!-- reserveCount -->
        <template slot="operation" slot-scope="text, record">
          <a @click="showmodel(text)">修改</a>
          <a-divider type="vertical" />
          <a @click="del(text)">删除</a>
        </template>
      </p-table>
    </p-card>

    <p-modal
      title="详情"
      width="50%"
      :visible="visible"
      :confirm-loading="confirmLoading"
      @ok="handleOk"
      @cancel="handleCancel"
    >
      <p-grid-form :label-col="{ span: 8 }" ref="model" :span="8" :items="config.Modelitems" @submit="hanlderSubmit" />
    </p-modal>
  </div>
</template>

<script>
import config from './config.js'

import { add, deletes, update } from './api'

export default {
  data() {
    return {
      config,
      data: [],
      selectedRowKeys: [],
      type: true,
      remoteParams: {
        areaNo: ''
      },
      visible: false,
      confirmLoading: false
    }
  },
  mounted() {
    // this.getinfo()
  },
  methods: {
    //批量删除
    delbatches() {
      let that = this
      console.log(this.selectedRowKeys)
      if (this.selectedRowKeys.length > 0) {
        this.$confirm({
          title: '确定是否要删除?',
          content: '',
          async onOk() {
            let res = await deletes(that.selectedRowKeys)
            if (res.success) {
              that.$message.success('删除成功')
              that.remoteParams = { ...that.remoteParams }
            } else {
              that.$exception(res)
            }
          },
          onCancel() {}
        })
      } else {
        this.$message.warning('请先选择要删除数据!')
      }
    },
    hanlderSubmit(e, form) {
      e.preventDefault()
      form.validateFields((error, values) => {
        console.log(error, values, 'valuesvaluesvaluesvaluesvalues')
        // this.queryName = values.name
        // this.queryType = values.type
        // this.getlistCompanyByAuthId()
        if (!error) {
          this.remoteParams = { ...this.remoteParams, ...values }
        }
      })
    },
    handleOk(e) {
      this.$refs.model.form.validateFields(async (err, value) => {
        if (!err) {
          console.log(value)
          this.confirmLoading = true
          if (this.type) {
            let res = await update(value)
            console.log(res)
            if (res.success) {
              this.visible = false
              this.$message.success(res.message)
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          } else {
            let res = await add(value)
            console.log(res)
            if (res.success) {
              this.visible = false
              this.$message.success(res.message)
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          }

          this.confirmLoading = false
          //
        }
      })
    },
    handleCancel(e) {
      console.log('Clicked cancel button')
      this.visible = false
    },
    //点击弹出
    showmodel(data) {
      console.log(data)

      if (data) {
        this.config.Modelitems.forEach(item => {
          if (item.label == '设备编号' || item.label == '区域编号') {
            item.disabled = true
          }
        })
        this.visible = true
        this.$nextTick(() => {
          console.log(this.config.items)

          this.$refs.model.form.setFieldsValue(data)
        })
        this.type = true
      } else {
        this.config.Modelitems.forEach(item => {
          if (item.label == '设备编号' || item.label == '区域编号') {
            item.disabled = false
          }
        })
        this.visible = true
        this.$nextTick(() => {
          this.$refs.model.form.resetFields()
        })
        this.type = false
      }
    },
    del(text) {
      let that = this
      console.log(text)
      this.$confirm({
        title: '确定是否要删除?',
        content: '',
        async onOk() {
          let res = await deletes([text.id])
          if (res.success) {
            that.$message.success('删除成功')
            that.remoteParams = { ...that.remoteParams }
          } else {
            that.$exception(res)
          }
        },
        onCancel() {}
      })
    }
  }
}
</script>

<style lang="less" scoped></style>
